// Asymptote file writer created by Michal Pytlos, May 2014

//This file is a part of Appendix C of: Pytlos, M. (2015), New tools for modelling soil-filled masonry arch bridges, 
//PhD thesis, Department of Civil and Structural Engineering, University of Sheffield, Sheffield.
//For the copyright details please search for the thesis on: http://etheses.whiterose.ac.uk/ 
//In no event will the author be held liable for any damages arising from the use of this computer program.

#include "ComputerGraphics.h"
using namespace std;
using std::vector;

myVector subtractVectors (const myVector& v1, const myVector& v2)
{
	myVector v_s;
	v_s.x=v1.x-v2.x;
	v_s.y=v1.y-v2.y;

	return v_s;
}

myVector rotateVector (float angle, const myVector& v) //angles in radians; rotate anticlockwise
{
	float s, c;
	s = sinf(angle);
	c = cosf(angle);

	//create rotation matrix	|r11 r12|
	//							|r21 r22|
		
	float r11, r12, r21, r22;
	r11 = c;
	r12 = -s;
	r21 = s;
	r22 = c;

	//multiply by column vector |r11 r12|	|x|
	//							|r21 r22|	|y|
		
	myVector v_g;
	v_g.x = r11*v.x + r12*v.y;
	v_g.y = r21*v.x + r22*v.y;

	return v_g;
};

